@echo off
@echo.
:: my custom CMake install path
set PATH=C:/apps/CMake/bin;%PATH%
::---------------------------------
:: Set some paths..
set ROOT_FOLDER=D:/REPOS/github/pbrt-v4
set DEPS_OUTPUT_FOLDER=D:/REPOS/github/pbrt-v4/3rdParty/msvc

::zlib
cd D:/REPOS/github/pbrt-v4/src/ext/zlib

:: fresh build
if exist build_msvc rmdir build_msvc /s /q
mkdir build_msvc
cd build_msvc

:: Generate project
call "C:\Program Files\Microsoft Visual Studio\2022\Community\VC\Auxiliary\Build\vcvars64.bat"

cmake -G "Visual Studio 17 2022" ../ -DCMAKE_INSTALL_PREFIX=%DEPS_OUTPUT_FOLDER%/zlib -DCMAKE_BUILD_TYPE="Release"

:: build and install a Release version
cmake --build . --config Release --target install

:: remove folder after build
cd ..
rmdir build_msvc /s /q
cd %ROOT_FOLDER%
:: add to the system path to allow find_package() to find.
set PATH=D:/REPOS/github/pbrt-v4/3rdParty/msvc/zlib;%PATH%

:: set main Pbrt4 project from a fresh build
if exist build rmdir build /s /q
mkdir build
cd build

:: Generate project for MSVC
:: This assume that you have MSVC in the default install folder
call "C:\Program Files\Microsoft Visual Studio\2022\Community\VC\Auxiliary\Build\vcvars64.bat" 
::
cmake -G "Visual Studio 17 2022" ../ -DPBRT_OPTIX7_PATH=D:/CUDA/OptiXSDK800 -DCMAKE_INSTALL_PREFIX=./pbrt4deploy -DCMAKE_BUILD_TYPE="Release"

:: build and install a Release version
cmake --build . --config Release --target install

if %ERRORLEVEL% NEQ 0 goto build_error
if %ERRORLEVEL% NEQ 1 goto succes

:build_error
echo "Error building project"
:: to allow looking for any debug console message
pause
goto end

:succes
:: back to sources folder
cd ..
echo "End build file sucessful"
pause
:end